import 'package:bizdoc/services/datasource.dart';
import 'package:flutter/material.dart';
import 'package:select_form_field/select_form_field.dart';

class Select extends StatefulWidget {
  final String dataType;
  final String? labelText;
  final String? initialValue;
  final Function(String?) onTap;
  const Select(
      {Key? key,
      required this.dataType,
      required this.onTap,
      this.labelText,
      this.initialValue})
      : super(key: key);
  @override
  _SelectState createState() => _SelectState();
}

class _SelectState extends State<Select> {
  @override
  Widget build(BuildContext context) {
    return FutureBuilder<Map>(
      future: dataSource.getMap(widget.dataType),
      builder: (context, snapshot) {
        if (snapshot.hasData) {
          final defaultValue =
              snapshot.data!.length == 1 ? snapshot.data!.keys.first : null;
          return SelectFormField(
            decoration: InputDecoration(labelText: widget.labelText),
            type: SelectFormFieldType.dropdown,
            initialValue: widget.initialValue ?? defaultValue,
            items: snapshot.data!.entries
                .map((e) => {'value': e.key, 'label': e.value})
                .toList(),
            onChanged: (value) => _tap(value),
          );
        }
        return Container();
      },
    );
  }

  void _tap(String? value) {
    widget.onTap(value);
  }
}
