import 'package:bizdoc/services/network.dart';
import 'package:dio/dio.dart';
import 'package:flutter/material.dart';

abstract class Service {
  @protected
  final dio = network.dio;

  @protected
  void handleError(DioError e) {
    switch (e.response?.statusCode) {
      case 409:
        throw ConflictError(e.response!.data);
      case 406:
        throw ValidationError(e.response!.data);
    }
  }
}

class UnauthorizedError {}

class ValidationError {
  final String message;

  ValidationError(this.message);
}

class ConflictError {
  final dynamic data;
  ConflictError(this.data);
}
