import 'base.dart';

class Datasource extends Service {
  final _cachedatasources = {};
  Future<Map<String, dynamic>> getMap(String name) async {
    if (_cachedatasources.containsKey(name)) {
      final data = await _cachedatasources[name];
      return data;
    }
    final response = await dio.get('/datatype/$name');

    return _cachedatasources[name] = response.data;
  }
}

final dataSource = Datasource();
